;-
;- G2F Animation v1.1 (RAM) by TeBe/Madteam (19.07.2004)
;- procedura pokazujaca poszczegolne mapy (klatki animacji)
;- kompresja znakow: OPTYMIZING, bez zmian kolorow co linie i obiektow PMG
;-

BAK equ $00
PF0 equ $04
PF1 equ $0C
PF2 equ $00
PF3 equ $0E

gfxMode  equ 2
width    equ 32
row_from equ 0
row_to   equ 26
height   equ row_to-row_from    ;wysokosc obrazu wyrazona w wierszach
size     equ width*height       ;dlugosc danych dla 1 ekranu
frames   equ 41                  ;liczba wszystkich ekranow
delay    equ 6                  ;opoznienie (fps)

 icl 'bubb.asq'

_txt     equ $0700
_tab     equ _txt+size
_txt2    equ _tab+height
_tab2    equ _txt2+size
free     equ _tab2+height

regA     equ $80     (1)
regY     equ regA+1  (1)
frm      equ regY+1  (1)
inp      equ frm+1   (2)
out      equ inp+2   (2)

;------------;
;- LET'S GO -;
;------------;
 org putFnt

;---------;
;- ANTIC -;
;---------;
ant
; dta d'ppp'
 dta $80,$40+$80+gfxMode
ant_adr dta a(_txt)
 :height-1 dta $80+gfxMode
 dta $41,a(ant)

animation
 lda 20
 cmp 20
 beq *-2
 
 sei
 lda #0
 sta $d40e
 lda #$fe
 sta $d301
 
 mwa #nmi $fffa
 
 lda #$c0
 sta $d40e
 
 ldx #1
 jsr wait

;---
 
start lda #frames
 sta frm
 mwa #data inp
 
loop lda #0
 eor #1
 sta loop+1
 bne faza2

faza1
 lda <_tab2             ; pokazuj drugi bufor
 sta tab_adr
 sta iy
 lda >_tab2
 sta tab_adr+1
 sta iy+1
 mwa #_txt2 ant_adr
 
 mwa #_txt out          ; rysuj w pierwszym buforze
 jmp _sh
 
faza2
 lda <_tab              ; pokazuj pierwszy bufor
 sta tab_adr
 sta iy
 lda >_tab
 sta tab_adr+1
 sta iy+1
 mwa #_txt ant_adr
 mwa tab_adr iy

 mwa #_txt2 out         ; rysuj w drugim buforze

_sh jsr depack

gate lda #0
 beq gate
 lda #0
 sta gate+1

_skp dec frm
 beq start_
 jmp loop

start_ jmp start

;--------;
;- WAIT -;
;--------;
wait lda #0
clock equ *-1
wai_ cmp clock
 beq wai_
 dex
 bne wait
 rts

;-------;
;- NMI -;
;-------;
nmi bit $d40f
 bpl vbl
 
dli sta regA
 sty regY

 ldy $ffff
iy equ *-2
 lda alloc,y
 sta $d40a
 sta $d409
 
 inw iy
 
 lda regA
 ldy regY
 rti

;-------;
;- VBL -;
;-------;
vbl sta regA
 sta $d40f
 
 inc clock
 
 mwa #ant $d402
 lda #%00100001
 sta $d400

 lda #BAK
 sta $d01a
 lda #PF0
 sta $d016
 lda #PF1
 sta $d017
 lda #PF2
 sta $d018
 lda #PF3
 sta $d019

 mwa tab_adr iy

 lda #0
fps equ *-1
 cmp #delay
 bne vblQ
 
 lda #$ff
 sta fps
 sta gate+1
 
vblQ inc fps

 lda regA
 rti

tab_adr dta a(_tab)
out_tmp dta a(_txt)

;----------;
;- DEPACK -;
;----------;
depack ldy #0
 lda (inp),y

 cmp #$c0
 bcs _sto
 cmp #$80
 bcs _rle
 cmp #$40
 bcs _inc

 inw inp
 rts

_sto inw inp

 and #$3f
 tay
 tax

_sto_l
 lda (inp),y
 sta (out),y
 dey
 bpl _sto_l
 
 txa
 jsr add_out
 txa
 jsr add_inp
 jmp depack


_inc tax
 iny
 lda (inp),y
 sta tmp_
 
 txa
 and #$3f
 tay
 tax

 sec
 lda #0
tmp_ equ *-1
_inc_l
 sta (out),y
 sbc #1
 dey
 bpl _inc_l
 
 txa
 jsr add_out
 lda #1
 jsr add_inp
 jmp depack


_rle tax
 iny
 lda (inp),y
 sta _tmp
 
 txa
 and #$3f
 tay
 tax

 lda #0
_tmp equ *-1
_rle_l
 sta (out),y
 dey
 bpl _rle_l
 
 txa
 jsr add_out
 lda #1
 jsr add_inp
 jmp depack

add_inp
 sec
 adc inp
 sta inp
 bcc *+4
 inc inp+1
 rts

add_out
 sec
 adc out
 sta out
 bcc *+4
 inc out+1
 rts

;---------;
;- FILES -;
;---------;
 org loaFnt
data ins 'bubb.frm'

;---
 run animation
